var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { customAlphabet } from 'nanoid';
import { nolookalikes } from 'nanoid-dictionary';
import base64url from 'base64url';
var cryptoPkg = require('crypto');
var blobToBase64 = function (blob) {
    return new Promise(function (resolve, reject) {
        var reader = new FileReader();
        reader.onloadend = function () {
            if (typeof reader.result === 'string') {
                resolve(reader.result);
            }
            else {
                reject(new Error('Failed to create base64 from blob.'));
            }
        };
        reader.readAsDataURL(blob);
    });
};
var importKeyFromString = function (key) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, crypto.subtle.importKey('jwk', {
                    kty: 'oct',
                    k: key,
                    alg: 'A256GCM',
                    ext: true
                }, { name: 'AES-GCM' }, true, ['encrypt', 'decrypt'])];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
export var encryptData = function (data, encryptionKey, nonce_length) {
    if (nonce_length === void 0) { nonce_length = 12; }
    return __awaiter(void 0, void 0, void 0, function () {
        var iv, cryptoKey, result, encryptedFile;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    iv = crypto.getRandomValues(new Uint8Array(nonce_length)) // Initialization Vector (IV)
                    ;
                    return [4 /*yield*/, importKeyFromString(encryptionKey)];
                case 1:
                    cryptoKey = _a.sent();
                    return [4 /*yield*/, crypto.subtle.encrypt({ name: 'AES-GCM', iv: iv }, cryptoKey, data)];
                case 2:
                    result = _a.sent();
                    encryptedFile = new Blob([iv, result]) // Adding IV
                    ;
                    return [2 /*return*/, encryptedFile];
            }
        });
    });
};
export var decryptData = function (data, decryptionKey, nonce_length) {
    if (nonce_length === void 0) { nonce_length = 12; }
    return __awaiter(void 0, void 0, void 0, function () {
        var key, _a, iv, body, decryptedData;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, importKeyFromString(decryptionKey)];
                case 1:
                    key = _b.sent();
                    return [4 /*yield*/, Promise.all([
                            data.slice(0, nonce_length).arrayBuffer(),
                            data.slice(nonce_length).arrayBuffer(), // The actual body. e.g. file content
                        ])];
                case 2:
                    _a = _b.sent(), iv = _a[0], body = _a[1];
                    return [4 /*yield*/, crypto.subtle.decrypt({
                            name: 'AES-GCM',
                            iv: iv
                        }, key, body)];
                case 3:
                    decryptedData = _b.sent();
                    return [2 /*return*/, decryptedData];
            }
        });
    });
};
export var generateEncryptionKeyString = function () { return __awaiter(void 0, void 0, void 0, function () {
    var key, exportedKey;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, crypto.subtle.generateKey({
                    name: 'AES-GCM',
                    length: 256
                }, true, ['encrypt', 'decrypt'])];
            case 1:
                key = _a.sent();
                return [4 /*yield*/, crypto.subtle.exportKey('jwk', key)];
            case 2:
                exportedKey = _a.sent();
                if (!exportedKey.k) {
                    throw new Error('Failed to generate encryption key.');
                }
                return [2 /*return*/, exportedKey.k];
        }
    });
}); };
export var encryptFile = function (file, encryptionKey, nonce_length) {
    if (nonce_length === void 0) { nonce_length = 12; }
    return __awaiter(void 0, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, file.arrayBuffer()];
                case 1:
                    data = _a.sent();
                    return [2 /*return*/, encryptData(data, encryptionKey, nonce_length)];
            }
        });
    });
};
export var decryptFile = function (file, decryptionKey, fileName, nonce_length) {
    if (nonce_length === void 0) { nonce_length = 12; }
    return __awaiter(void 0, void 0, void 0, function () {
        var decryptedData;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, decryptData(file, decryptionKey, nonce_length)];
                case 1:
                    decryptedData = _a.sent();
                    return [2 /*return*/, new File([decryptedData], fileName)];
            }
        });
    });
};
export var encryptString = function (text, encryptionKey, nonce_length) {
    if (nonce_length === void 0) { nonce_length = 12; }
    return __awaiter(void 0, void 0, void 0, function () {
        var encoder, data, encryptedData, encryptedDataBase64;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    encoder = new TextEncoder();
                    data = encoder.encode(text);
                    return [4 /*yield*/, encryptData(data, encryptionKey, nonce_length)];
                case 1:
                    encryptedData = _a.sent();
                    return [4 /*yield*/, blobToBase64(encryptedData)];
                case 2:
                    encryptedDataBase64 = _a.sent();
                    return [2 /*return*/, encryptedDataBase64];
            }
        });
    });
};
export var decryptString = function (base64DataUrl, decryptionKey, nonce_length) {
    if (nonce_length === void 0) { nonce_length = 12; }
    return __awaiter(void 0, void 0, void 0, function () {
        var base64Response, blob, decryptedData, decoder, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(base64DataUrl)];
                case 1:
                    base64Response = _a.sent();
                    return [4 /*yield*/, base64Response.blob()];
                case 2:
                    blob = _a.sent();
                    return [4 /*yield*/, decryptData(blob, decryptionKey, nonce_length)];
                case 3:
                    decryptedData = _a.sent();
                    decoder = new TextDecoder();
                    result = decoder.decode(decryptedData);
                    return [2 /*return*/, result];
            }
        });
    });
};
export var generateNanoId = function (length) {
    var nanoid = customAlphabet(nolookalikes, length);
    return nanoid();
};
export var createHashWithoutPadding = function (val) {
    return createHash(val).replace(/=/g, '');
};
export var createHash = function (val) {
    var hash = cryptoPkg.createHash('sha256').update(Buffer.from(val)).digest();
    return base64url.encode(hash);
};
